Index: /branches/2988_ModelsOfModels2/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeLinearInterpreter.cs
===================================================================
--- /branches/2988_ModelsOfModels2/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeLinearInterpreter.cs	(revision 16898)
+++ /branches/2988_ModelsOfModels2/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeLinearInterpreter.cs	(revision 16899)
@@ -133,5 +133,5 @@
       }
 
-      var code = SymbolicExpressionTreeLinearCompiler.Compile(tree, OpCodes.MapSymbolToOpCode);
+      var code = SymbolicExpressionTreeLinearCompiler.Compile(tree, OpCode.MapSymbolToOpCode);
       PrepareInstructions(code, dataset);
       return rows.Select(row => Evaluate(dataset, row, code));
@@ -143,5 +143,5 @@
         #region opcode if
         var instr = code[i];
-        if (instr.opCode == OpCodes.Variable) {
+        if (instr.opCode == OpCode.Variable) {
           if (row < 0 || row >= dataset.Rows) instr.value = double.NaN;
           else {
@@ -149,5 +149,5 @@
             instr.value = ((IList<double>)instr.data)[row] * variableTreeNode.Weight;
           }
-        } else if (instr.opCode == OpCodes.BinaryFactorVariable) {
+        } else if (instr.opCode == OpCode.BinaryFactorVariable) {
           if (row < 0 || row >= dataset.Rows) instr.value = double.NaN;
           else {
@@ -155,5 +155,5 @@
             instr.value = ((IList<string>)instr.data)[row] == factorTreeNode.VariableValue ? factorTreeNode.Weight : 0;
           }
-        } else if (instr.opCode == OpCodes.FactorVariable) {
+        } else if (instr.opCode == OpCode.FactorVariable) {
           if (row < 0 || row >= dataset.Rows) instr.value = double.NaN;
           else {
@@ -161,5 +161,5 @@
             instr.value = factorTreeNode.GetValue(((IList<string>)instr.data)[row]);
           }
-        } else if (instr.opCode == OpCodes.LagVariable) {
+        } else if (instr.opCode == OpCode.LagVariable) {
           var laggedVariableTreeNode = (LaggedVariableTreeNode)instr.dynamicNode;
           int actualRow = row + laggedVariableTreeNode.Lag;
@@ -168,5 +168,5 @@
           else
             instr.value = ((IList<double>)instr.data)[actualRow] * laggedVariableTreeNode.Weight;
-        } else if (instr.opCode == OpCodes.VariableCondition) {
+        } else if (instr.opCode == OpCode.VariableCondition) {
           if (row < 0 || row >= dataset.Rows) instr.value = double.NaN;
           var variableConditionTreeNode = (VariableConditionTreeNode)instr.dynamicNode;
@@ -188,5 +188,5 @@
             }
           }
-        } else if (instr.opCode == OpCodes.Add) {
+        } else if (instr.opCode == OpCode.Add) {
           double s = code[instr.childIndex].value;
           for (int j = 1; j != instr.nArguments; ++j) {
@@ -194,5 +194,5 @@
           }
           instr.value = s;
-        } else if (instr.opCode == OpCodes.Sub) {
+        } else if (instr.opCode == OpCode.Sub) {
           double s = code[instr.childIndex].value;
           for (int j = 1; j != instr.nArguments; ++j) {
@@ -201,5 +201,5 @@
           if (instr.nArguments == 1) s = -s;
           instr.value = s;
-        } else if (instr.opCode == OpCodes.Mul) {
+        } else if (instr.opCode == OpCode.Mul) {
           double p = code[instr.childIndex].value;
           for (int j = 1; j != instr.nArguments; ++j) {
@@ -207,5 +207,5 @@
           }
           instr.value = p;
-        } else if (instr.opCode == OpCodes.Div) {
+        } else if (instr.opCode == OpCode.Div) {
           double p = code[instr.childIndex].value;
           for (int j = 1; j != instr.nArguments; ++j) {
@@ -214,9 +214,9 @@
           if (instr.nArguments == 1) p = 1.0 / p;
           instr.value = p;
-        } else if (instr.opCode == OpCodes.AnalyticQuotient) {
+        } else if (instr.opCode == OpCode.AnalyticQuotient) {
           var x1 = code[instr.childIndex].value;
           var x2 = code[instr.childIndex + 1].value;
           instr.value = x1 / Math.Sqrt(1 + x2 * x2);
-        } else if (instr.opCode == OpCodes.Average) {
+        } else if (instr.opCode == OpCode.Average) {
           double s = code[instr.childIndex].value;
           for (int j = 1; j != instr.nArguments; ++j) {
@@ -224,49 +224,49 @@
           }
           instr.value = s / instr.nArguments;
-        } else if (instr.opCode == OpCodes.Absolute) {
+        } else if (instr.opCode == OpCode.Absolute) {
           instr.value = Math.Abs(code[instr.childIndex].value);
-        } else if (instr.opCode == OpCodes.Tanh) {
+        } else if (instr.opCode == OpCode.Tanh) {
           instr.value = Math.Tanh(code[instr.childIndex].value);
-        } else if (instr.opCode == OpCodes.Cos) {
+        } else if (instr.opCode == OpCode.Cos) {
           instr.value = Math.Cos(code[instr.childIndex].value);
-        } else if (instr.opCode == OpCodes.Sin) {
+        } else if (instr.opCode == OpCode.Sin) {
           instr.value = Math.Sin(code[instr.childIndex].value);
-        } else if (instr.opCode == OpCodes.Tan) {
+        } else if (instr.opCode == OpCode.Tan) {
           instr.value = Math.Tan(code[instr.childIndex].value);
-        } else if (instr.opCode == OpCodes.Square) {
+        } else if (instr.opCode == OpCode.Square) {
           instr.value = Math.Pow(code[instr.childIndex].value, 2);
-        } else if (instr.opCode == OpCodes.Cube) {
+        } else if (instr.opCode == OpCode.Cube) {
           instr.value = Math.Pow(code[instr.childIndex].value, 3);
-        } else if (instr.opCode == OpCodes.Power) {
+        } else if (instr.opCode == OpCode.Power) {
           double x = code[instr.childIndex].value;
           double y = Math.Round(code[instr.childIndex + 1].value);
           instr.value = Math.Pow(x, y);
-        } else if (instr.opCode == OpCodes.SquareRoot) {
+        } else if (instr.opCode == OpCode.SquareRoot) {
           instr.value = Math.Sqrt(code[instr.childIndex].value);
-        } else if (instr.opCode == OpCodes.CubeRoot) {
+        } else if (instr.opCode == OpCode.CubeRoot) {
           instr.value = Math.Pow(code[instr.childIndex].value, 1.0 / 3.0);
-        } else if (instr.opCode == OpCodes.Root) {
+        } else if (instr.opCode == OpCode.Root) {
           double x = code[instr.childIndex].value;
           double y = Math.Round(code[instr.childIndex + 1].value);
           instr.value = Math.Pow(x, 1 / y);
-        } else if (instr.opCode == OpCodes.Exp) {
+        } else if (instr.opCode == OpCode.Exp) {
           instr.value = Math.Exp(code[instr.childIndex].value);
-        } else if (instr.opCode == OpCodes.Log) {
+        } else if (instr.opCode == OpCode.Log) {
           instr.value = Math.Log(code[instr.childIndex].value);
-        } else if (instr.opCode == OpCodes.Gamma) {
+        } else if (instr.opCode == OpCode.Gamma) {
           var x = code[instr.childIndex].value;
           instr.value = double.IsNaN(x) ? double.NaN : alglib.gammafunction(x);
-        } else if (instr.opCode == OpCodes.Psi) {
+        } else if (instr.opCode == OpCode.Psi) {
           var x = code[instr.childIndex].value;
           if (double.IsNaN(x)) instr.value = double.NaN;
           else if (x <= 0 && (Math.Floor(x) - x).IsAlmost(0)) instr.value = double.NaN;
           else instr.value = alglib.psi(x);
-        } else if (instr.opCode == OpCodes.Dawson) {
+        } else if (instr.opCode == OpCode.Dawson) {
           var x = code[instr.childIndex].value;
           instr.value = double.IsNaN(x) ? double.NaN : alglib.dawsonintegral(x);
-        } else if (instr.opCode == OpCodes.ExponentialIntegralEi) {
+        } else if (instr.opCode == OpCode.ExponentialIntegralEi) {
           var x = code[instr.childIndex].value;
           instr.value = double.IsNaN(x) ? double.NaN : alglib.exponentialintegralei(x);
-        } else if (instr.opCode == OpCodes.SineIntegral) {
+        } else if (instr.opCode == OpCode.SineIntegral) {
           double si, ci;
           var x = code[instr.childIndex].value;
@@ -276,5 +276,5 @@
             instr.value = si;
           }
-        } else if (instr.opCode == OpCodes.CosineIntegral) {
+        } else if (instr.opCode == OpCode.CosineIntegral) {
           double si, ci;
           var x = code[instr.childIndex].value;
@@ -284,5 +284,5 @@
             instr.value = ci;
           }
-        } else if (instr.opCode == OpCodes.HyperbolicSineIntegral) {
+        } else if (instr.opCode == OpCode.HyperbolicSineIntegral) {
           double shi, chi;
           var x = code[instr.childIndex].value;
@@ -292,5 +292,5 @@
             instr.value = shi;
           }
-        } else if (instr.opCode == OpCodes.HyperbolicCosineIntegral) {
+        } else if (instr.opCode == OpCode.HyperbolicCosineIntegral) {
           double shi, chi;
           var x = code[instr.childIndex].value;
@@ -300,5 +300,5 @@
             instr.value = chi;
           }
-        } else if (instr.opCode == OpCodes.FresnelCosineIntegral) {
+        } else if (instr.opCode == OpCode.FresnelCosineIntegral) {
           double c = 0, s = 0;
           var x = code[instr.childIndex].value;
@@ -308,5 +308,5 @@
             instr.value = c;
           }
-        } else if (instr.opCode == OpCodes.FresnelSineIntegral) {
+        } else if (instr.opCode == OpCode.FresnelSineIntegral) {
           double c = 0, s = 0;
           var x = code[instr.childIndex].value;
@@ -316,5 +316,5 @@
             instr.value = s;
           }
-        } else if (instr.opCode == OpCodes.AiryA) {
+        } else if (instr.opCode == OpCode.AiryA) {
           double ai, aip, bi, bip;
           var x = code[instr.childIndex].value;
@@ -324,5 +324,5 @@
             instr.value = ai;
           }
-        } else if (instr.opCode == OpCodes.AiryB) {
+        } else if (instr.opCode == OpCode.AiryB) {
           double ai, aip, bi, bip;
           var x = code[instr.childIndex].value;
@@ -332,17 +332,17 @@
             instr.value = bi;
           }
-        } else if (instr.opCode == OpCodes.Norm) {
+        } else if (instr.opCode == OpCode.Norm) {
           var x = code[instr.childIndex].value;
           if (double.IsNaN(x)) instr.value = double.NaN;
           else instr.value = alglib.normaldistribution(x);
-        } else if (instr.opCode == OpCodes.Erf) {
+        } else if (instr.opCode == OpCode.Erf) {
           var x = code[instr.childIndex].value;
           if (double.IsNaN(x)) instr.value = double.NaN;
           else instr.value = alglib.errorfunction(x);
-        } else if (instr.opCode == OpCodes.Bessel) {
+        } else if (instr.opCode == OpCode.Bessel) {
           var x = code[instr.childIndex].value;
           if (double.IsNaN(x)) instr.value = double.NaN;
           else instr.value = alglib.besseli0(x);
-        } else if (instr.opCode == OpCodes.IfThenElse) {
+        } else if (instr.opCode == OpCode.IfThenElse) {
           double condition = code[instr.childIndex].value;
           double result;
@@ -353,5 +353,5 @@
           }
           instr.value = result;
-        } else if (instr.opCode == OpCodes.AND) {
+        } else if (instr.opCode == OpCode.AND) {
           double result = code[instr.childIndex].value;
           for (int j = 1; j < instr.nArguments; j++) {
@@ -360,5 +360,5 @@
           }
           instr.value = result > 0.0 ? 1.0 : -1.0;
-        } else if (instr.opCode == OpCodes.OR) {
+        } else if (instr.opCode == OpCode.OR) {
           double result = code[instr.childIndex].value;
           for (int j = 1; j < instr.nArguments; j++) {
@@ -367,7 +367,7 @@
           }
           instr.value = result > 0.0 ? 1.0 : -1.0;
-        } else if (instr.opCode == OpCodes.NOT) {
+        } else if (instr.opCode == OpCode.NOT) {
           instr.value = code[instr.childIndex].value > 0.0 ? -1.0 : 1.0;
-        } else if (instr.opCode == OpCodes.XOR) {
+        } else if (instr.opCode == OpCode.XOR) {
           int positiveSignals = 0;
           for (int j = 0; j < instr.nArguments; j++) {
@@ -375,13 +375,13 @@
           }
           instr.value = positiveSignals % 2 != 0 ? 1.0 : -1.0;
-        } else if (instr.opCode == OpCodes.GT) {
+        } else if (instr.opCode == OpCode.GT) {
           double x = code[instr.childIndex].value;
           double y = code[instr.childIndex + 1].value;
           instr.value = x > y ? 1.0 : -1.0;
-        } else if (instr.opCode == OpCodes.LT) {
+        } else if (instr.opCode == OpCode.LT) {
           double x = code[instr.childIndex].value;
           double y = code[instr.childIndex + 1].value;
           instr.value = x < y ? 1.0 : -1.0;
-        } else if (instr.opCode == OpCodes.TimeLag || instr.opCode == OpCodes.Derivative || instr.opCode == OpCodes.Integral) {
+        } else if (instr.opCode == OpCode.TimeLag || instr.opCode == OpCode.Derivative || instr.opCode == OpCode.Integral) {
           var state = (InterpreterState)instr.data;
           state.Reset();
@@ -415,5 +415,5 @@
         #region opcode switch
         switch (instr.opCode) {
-          case OpCodes.Constant: {
+          case OpCode.Constant: {
               var constTreeNode = (ConstantTreeNode)instr.dynamicNode;
               instr.value = constTreeNode.Value;
@@ -421,32 +421,32 @@
             }
             break;
-          case OpCodes.Variable: {
+          case OpCode.Variable: {
               var variableTreeNode = (VariableTreeNode)instr.dynamicNode;
               instr.data = dataset.GetReadOnlyDoubleValues(variableTreeNode.VariableName);
             }
             break;
-          case OpCodes.BinaryFactorVariable: {
+          case OpCode.BinaryFactorVariable: {
               var factorVariableTreeNode = instr.dynamicNode as BinaryFactorVariableTreeNode;
               instr.data = dataset.GetReadOnlyStringValues(factorVariableTreeNode.VariableName);
             }
             break;
-          case OpCodes.FactorVariable: {
+          case OpCode.FactorVariable: {
               var factorVariableTreeNode = instr.dynamicNode as FactorVariableTreeNode;
               instr.data = dataset.GetReadOnlyStringValues(factorVariableTreeNode.VariableName);
             }
             break;
-          case OpCodes.LagVariable: {
+          case OpCode.LagVariable: {
               var laggedVariableTreeNode = (LaggedVariableTreeNode)instr.dynamicNode;
               instr.data = dataset.GetReadOnlyDoubleValues(laggedVariableTreeNode.VariableName);
             }
             break;
-          case OpCodes.VariableCondition: {
+          case OpCode.VariableCondition: {
               var variableConditionTreeNode = (VariableConditionTreeNode)instr.dynamicNode;
               instr.data = dataset.GetReadOnlyDoubleValues(variableConditionTreeNode.VariableName);
             }
             break;
-          case OpCodes.TimeLag:
-          case OpCodes.Integral:
-          case OpCodes.Derivative: {
+          case OpCode.TimeLag:
+          case OpCode.Integral:
+          case OpCode.Derivative: {
               var seq = GetPrefixSequence(code, i);
               var interpreterState = new InterpreterState(seq, 0);
Index: /branches/2988_ModelsOfModels2/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeNativeInterpreter.cs
===================================================================
--- /branches/2988_ModelsOfModels2/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeNativeInterpreter.cs	(revision 16898)
+++ /branches/2988_ModelsOfModels2/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeNativeInterpreter.cs	(revision 16899)
@@ -20,8 +20,5 @@
 #endregion
 
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Runtime.InteropServices;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -29,5 +26,8 @@
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
 using HeuristicLab.Parameters;
-using HEAL.Attic;
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Runtime.InteropServices;
 
 namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
@@ -101,4 +101,27 @@
     private IDataset dataset;
 
+    private static readonly HashSet<byte> supportedOpCodes = new HashSet<byte>() {
+      (byte)OpCode.Constant,
+      (byte)OpCode.Variable,
+      (byte)OpCode.Add,
+      (byte)OpCode.Sub,
+      (byte)OpCode.Mul,
+      (byte)OpCode.Div,
+      (byte)OpCode.Exp,
+      (byte)OpCode.Log,
+      (byte)OpCode.Sin,
+      (byte)OpCode.Cos,
+      (byte)OpCode.Tan,
+      (byte)OpCode.Tanh,
+      (byte)OpCode.Power,
+      (byte)OpCode.Root,
+      (byte)OpCode.SquareRoot,
+      (byte)OpCode.Square,
+      (byte)OpCode.CubeRoot,
+      (byte)OpCode.Cube,
+      (byte)OpCode.Absolute,
+      (byte)OpCode.AnalyticQuotient
+    };
+
     public IEnumerable<double> GetSymbolicExpressionTreeValues(ISymbolicExpressionTree tree, IDataset dataset, IEnumerable<int> rows) {
       if (!rows.Any()) return Enumerable.Empty<double>();
@@ -108,5 +131,10 @@
       }
 
-      var code = Compile(tree, OpCodes.MapSymbolToOpCode);
+      byte mapSupportedSymbols(ISymbolicExpressionTreeNode node) {
+        var opCode = OpCode.MapSymbolToOpCode(node);
+        if (supportedOpCodes.Contains(opCode)) return opCode;
+        else throw new NotSupportedException($"The native interpreter does not support {node.Symbol.Name}");
+      };
+      var code = Compile(tree, mapSupportedSymbols);
 
       var rowsArray = rows.ToArray();
Index: /branches/2988_ModelsOfModels2/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Selectors/DiversitySelector.cs
===================================================================
--- /branches/2988_ModelsOfModels2/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Selectors/DiversitySelector.cs	(revision 16898)
+++ /branches/2988_ModelsOfModels2/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Selectors/DiversitySelector.cs	(revision 16899)
@@ -100,6 +100,14 @@
     #region Events
     private void RegisterParameterEventHandlers() {
-      SelectorParameter.ValueChanged += new EventHandler(SelectorParameter_ValueChanged);
-      CopySelected.ValueChanged += new EventHandler(CopySelected_ValueChanged);
+      SelectorParameter.ValueChanged += SelectorParameter_ValueChanged;
+      CopySelectedParameter.ValueChanged += CopySelectedParameter_ValueChanged;
+      CopySelected.ValueChanged += CopySelected_ValueChanged;
+    }
+
+    private void CopySelectedParameter_ValueChanged(object sender, EventArgs e) {
+      if (CopySelected.Value != true) {
+        CopySelected.Value = true;
+      }
+      CopySelected.ValueChanged += CopySelected_ValueChanged;
     }
 
Index: /branches/2988_ModelsOfModels2/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisModelComplexityCalculator.cs
===================================================================
--- /branches/2988_ModelsOfModels2/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisModelComplexityCalculator.cs	(revision 16898)
+++ /branches/2988_ModelsOfModels2/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisModelComplexityCalculator.cs	(revision 16899)
@@ -35,15 +35,15 @@
       if (node.Symbol is StartSymbol) node = node.GetSubtree(0);
 
-      switch (OpCodes.MapSymbolToOpCode(node)) {
-        case OpCodes.Constant: {
+      switch (OpCode.MapSymbolToOpCode(node)) {
+        case OpCode.Constant: {
             return 1;
           }
-        case OpCodes.Variable:
-        case OpCodes.BinaryFactorVariable:
-        case OpCodes.FactorVariable: {
+        case OpCode.Variable:
+        case OpCode.BinaryFactorVariable:
+        case OpCode.FactorVariable: {
             return 2;
           }
-        case OpCodes.Add:
-        case OpCodes.Sub: {
+        case OpCode.Add:
+        case OpCode.Sub: {
             double complexity = 0;
             for (int i = 0; i < node.SubtreeCount; i++) {
@@ -52,6 +52,6 @@
             return complexity;
           }
-        case OpCodes.Mul:
-        case OpCodes.Div: {
+        case OpCode.Mul:
+        case OpCode.Div: {
             double complexity = 1;
             for (int i = 0; i < node.SubtreeCount; i++) {
@@ -61,22 +61,22 @@
             return complexity;
           }
-        case OpCodes.Sin:
-        case OpCodes.Cos:
-        case OpCodes.Tan:
-        case OpCodes.Exp:
-        case OpCodes.Log: {
+        case OpCode.Sin:
+        case OpCode.Cos:
+        case OpCode.Tan:
+        case OpCode.Exp:
+        case OpCode.Log: {
             double complexity = CalculateComplexity(node.GetSubtree(0));
             return Math.Pow(2.0, complexity);
           }
-        case OpCodes.Square: {
+        case OpCode.Square: {
             double complexity = CalculateComplexity(node.GetSubtree(0));
             return complexity * complexity;
           }
-        case OpCodes.SquareRoot: {
+        case OpCode.SquareRoot: {
             double complexity = CalculateComplexity(node.GetSubtree(0));
             return complexity * complexity * complexity;
           }
-        case OpCodes.Power:
-        case OpCodes.Root: {
+        case OpCode.Power:
+        case OpCode.Root: {
             double complexity = CalculateComplexity(node.GetSubtree(0));
             var exponent = node.GetSubtree(1) as ConstantTreeNode;
Index: /branches/2988_ModelsOfModels2/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/ModelTreeNode.cs
===================================================================
--- /branches/2988_ModelsOfModels2/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/ModelTreeNode.cs	(revision 16898)
+++ /branches/2988_ModelsOfModels2/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/ModelTreeNode.cs	(revision 16899)
@@ -57,5 +57,5 @@
     private TreeModelTreeNode(TreeModelTreeNode original, Cloner cloner)
       : base(original, cloner) {
-      tree = original.tree;
+      tree = (ISymbolicExpressionTree)original.tree.Clone(cloner);
       ClusterNumer = original.ClusterNumer;
       TreeNumber = original.TreeNumber;
